package com.ghome.sdk.demo;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Toast;

import com.ghome.gshare.GShareInterface;
import com.ghome.gshare.GSharePlatformType;
import com.ghome.gshare.listener.GShareListener;
import com.ghome.gshare.listener.GShareRecordListener;
import com.ghome.gshare.share_media.GShareBaseMedia;
import com.ghome.gshare.share_media.GShareSystemPrimalImageMedia;
import com.ghome.gshare.share_media.GShareSystemPrimalMusicMedia;
import com.ghome.gshare.share_media.GShareSystemPrimalVideoMedia;
import com.ghome.gshare.share_media.GShareTextMedia;
import com.ghome.gshare.share_media.GShareVendorSDKImageMedia;
import com.ghome.gshare.share_media.GShareVendorSDKMusicMedia;
import com.ghome.gshare.share_media.GShareVendorSDKVideoMedia;
import com.ghome.gshare.share_media.GShareWebMedia;
import com.ghome.gshare.util.GShareBaseUtility;
import com.ghome.sdk.common.WXEntryThirdHandler;
import com.ghomesdk.gameplus.utils.log.Log;
import com.tencent.mm.opensdk.modelbase.BaseReq;
import com.tencent.mm.opensdk.modelbase.BaseResp;
import com.tencent.mm.opensdk.modelmsg.SendMessageToWX;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class GShareEngineActivity extends Activity {
    private RadioGroup m_radioGShareMedia;
    private RadioGroup m_radioGShareType;

    private static final String WX_APP_ID = "wx4b5f6da6126099ec";
    private static final String QQ_APP_ID = "101562812";
    private static final String SINA_WB_APP_KEY = "4115557623";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // 加载主视图布局
        setContentView(R.layout.activity_gshare_engine);

        // radio group 组件视图
        m_radioGShareMedia = findViewById(R.id.radioGShareMedia);
        m_radioGShareType = findViewById(R.id.radioGShareType);
    }

    @Override
    protected void onDestroy() {
        GShareInterface.free();
        super.onDestroy();
    }

    // 本例中, 主要用于系统分享. 三方SDK只视频分享用此路径
    private void copyAssetsFileToSDCard(String strAssetsFilePath, String strOutFilePath) throws IOException{
        Log.error("GShareEngineActivity", "strOutFilePath: " + strOutFilePath);
        InputStream input;
        OutputStream output = new FileOutputStream(strOutFilePath);
        input = this.getAssets().open(strAssetsFilePath);
        if (null == input) {
            return;
        }
        byte[] buffer = new byte[1024];
        int length = input.read(buffer);
        while (0 < length) {
            output.write(buffer, 0, length);
            length = input.read(buffer);
        }
        output.flush();
        input.close();
        output.close();
    }

    // 分享方式 radio group 视图响应方法
    public void onBtnShareTypeClick(View view) {
        ((RadioButton) findViewById(R.id.radioShareText)).setChecked(true);
    }

    // 分享文件类型 radio group 视图响应方法
    public void onBtnShareMediaTypeClick(View view) {
    }


    // 触发分享
    public void onBtnShareClick(View view) {
//        WXEntryThirdHandler.getInstance().handle(this, new WXEntryThirdHandler.WXEntryThirdHandlerListener() {
//            @Override
//            public void onReq(BaseReq baseReq) {
//                Log.debug("GShareEngineActivity", "wxentryThirdHandler onReq");
//                Toast.makeText(GShareEngineActivity.this, "Demo: WXEntryThirdHandler onReq", Toast.LENGTH_SHORT).show();
//
//            }
//
//            @Override
//            public void onResp(BaseResp baseResp) {
//                Log.debug("GShareEngineActivity", "wxentryThirdHandler onResp");
//                Toast.makeText(GShareEngineActivity.this, "Demo: WXEntryThirdHandler onResp 转发", Toast.LENGTH_SHORT).show();
////                GShareInterface.getInstance(GShareEngineActivity.this).onShareCallback((SendMessageToWX.Resp) baseResp);
//            }
//        });
        //	用于统计
//		GShareInterface.intentToShare( "消灭世界boss黑暗魔王" );

        // 分享方式： 0 = 第三方SDK分享； 1 = 系统原生API分享, 推荐使用第三方sdk分享，具体细节请看接入文档
        int nShareType = 0;
        if (R.id.radioSystemPrimal == m_radioGShareType.getCheckedRadioButtonId()) {
            nShareType = 1;
        }

        // 分享的文件的存储位置.
        String externalFilesDirPath = "";
        try {
            externalFilesDirPath = getExternalFilesDir(null).toString();
        } catch (Exception e) {
            GShareBaseUtility.doLogger("get external files dir failed. Exception message is : " + e.getMessage());
        }

        // 分享的文件类型
        GShareBaseMedia shareMedia;
        int radioButtonId = m_radioGShareMedia.getCheckedRadioButtonId();
        if (radioButtonId == R.id.radioShareText) { // 文件类型为文字
            shareMedia = new GShareTextMedia();
            ((GShareTextMedia) shareMedia).setText("分享文字测试");
        } else if (radioButtonId == R.id.radioShareImage) { // 文件类型为图片
            if (0 == nShareType) { // 三方SDK分享方式
                shareMedia = new GShareVendorSDKImageMedia();
                ((GShareVendorSDKImageMedia) shareMedia).setImage(BitmapFactory.decodeResource(getResources(), R.drawable.gshare));
            } else { // 系统分享方式
                shareMedia = new GShareSystemPrimalImageMedia();
                ((GShareSystemPrimalImageMedia) shareMedia).setDescription("http://baidu.com");
                try {
                    // 图片保存到SDCard， 后面根据文件路径拿到文件进行分享
                    copyAssetsFileToSDCard("gshare1.jpg", externalFilesDirPath + "/" + "gshare1.jpg");
//                    if (R.id.radioShareWXCircle != m_radioGSharePlatform.getCheckedRadioButtonId()) { // 分享平台非朋友圈则多分享一张图片
                        copyAssetsFileToSDCard("gshare3.png", externalFilesDirPath + "/" + "gshare3.png");
//                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
                ((GShareSystemPrimalImageMedia) shareMedia).addMediaPath(externalFilesDirPath + "/" + "gshare1.jpg");
//                if (R.id.radioShareWXCircle != m_radioGSharePlatform.getCheckedRadioButtonId()) { // 分享平台非朋友圈则多分享一张图片
                    ((GShareSystemPrimalImageMedia) shareMedia).addMediaPath(externalFilesDirPath + "/" + "gshare3.png");
//                }
            }
        } else if (radioButtonId == R.id.radioShareMusic) { // 分享类型为音乐
            if (0 == nShareType) { // 第三方SDK分享
                shareMedia = new GShareVendorSDKMusicMedia();
                ((GShareVendorSDKMusicMedia) shareMedia).setTitle("虾米音乐");
                ((GShareVendorSDKMusicMedia) shareMedia).setDescription("我正在虾米音乐收听歌曲，邀请你一起来听");
                ((GShareVendorSDKMusicMedia) shareMedia).setMusicUrl("http://www.xiami.com/play?ids=/song/playlist/id/2124062#loaded");
                ((GShareVendorSDKMusicMedia) shareMedia).setThumb(BitmapFactory.decodeResource(getResources(), R.drawable.ic_launcher));
            } else { // 系统分享
                shareMedia = new GShareSystemPrimalMusicMedia();
                ((GShareSystemPrimalMusicMedia) shareMedia).setDescription("音乐分享.");
                try {
                    copyAssetsFileToSDCard("gshare1.mp3", externalFilesDirPath + "/" + "gshare1.mp3");
//                    copyAssetsFileToSDCard("gshare2.mp3", externalFilesDirPath + "/" + "gshare2.mp3");
                } catch (IOException e) {
                    e.printStackTrace();
                }
                ((GShareSystemPrimalMusicMedia) shareMedia).addMediaPath(externalFilesDirPath + "/" + "gshare1.mp3");
//                ((GShareSystemPrimalMusicMedia) shareMedia).addMediaPath(externalFilesDirPath + "/" + "gshare2.mp3");
            }
        } else if (radioButtonId == R.id.radioShareVideoLocal) { // 分享视频
            if (0 == nShareType) { // 第三方SDK分享
                shareMedia = new GShareVendorSDKVideoMedia();
                try {
                    copyAssetsFileToSDCard("gshare1.mp4", externalFilesDirPath + "/" + "gshare1.mp4");
                    ((GShareVendorSDKVideoMedia) shareMedia).setDescription("可爱的狗子");
                    ((GShareVendorSDKVideoMedia) shareMedia).setVideoUrl(externalFilesDirPath + "/" + "gshare1.mp4");
                } catch (IOException e) {
                    e.printStackTrace();
                }
            } else { // 系统分享
                shareMedia = new GShareSystemPrimalVideoMedia();
                ((GShareSystemPrimalVideoMedia) shareMedia).setDescription("视频分享.");
                try {
                    copyAssetsFileToSDCard("gshare1.mp4", externalFilesDirPath + "/" + "gshare1.mp4");
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
                ((GShareSystemPrimalVideoMedia) shareMedia).addMediaPath(externalFilesDirPath + "/" + "gshare1.mp4");
            }
        } else if (radioButtonId == R.id.radioShareVideoOnline) { // 分享在线视频
            if (0 == nShareType) { // 第三方SDK分享
                shareMedia = new GShareVendorSDKVideoMedia();
                ((GShareVendorSDKVideoMedia) shareMedia).setTitle("优酷视频");
                ((GShareVendorSDKVideoMedia) shareMedia).setDescription("我正在优酷视频观看视频，邀请你一起来看");
                ((GShareVendorSDKVideoMedia) shareMedia).setVideoUrl("http://v.youku.com/v_show/id_XMTY2NzU1MzM4NA==.html?spm=a2hww.20023042.m_223473.5~5!3~5!2~5~A&from=y1.3-idx-beta-1519-23042.223471-223473.5-1");
                ((GShareVendorSDKVideoMedia) shareMedia).setThumb(BitmapFactory.decodeResource(getResources(), R.drawable.ic_launcher));
            } else { // 系统分享
                shareMedia = new GShareSystemPrimalVideoMedia();
                ((GShareSystemPrimalVideoMedia) shareMedia).setDescription("视频分享.");
                try {
                    copyAssetsFileToSDCard("gshare1.mp4", externalFilesDirPath + "/" + "gshare1.mp4");
                } catch (IOException e) {
                    e.printStackTrace();
                }
                ((GShareSystemPrimalVideoMedia) shareMedia).addMediaPath(externalFilesDirPath + "/" + "gshare1.mp4");
            }
        }else if (radioButtonId == R.id.radioShareWeb) { // 分享web
            shareMedia = new GShareWebMedia();
            ((GShareWebMedia) shareMedia).setTitle("百度一下");
            ((GShareWebMedia) shareMedia).setDescription("我正在看百度，邀请你一起关注百度");
            ((GShareWebMedia) shareMedia).setWebPageUrl("http://mp.weixin.qq.com/s/eG51Z3nRey108J8r1FYsKw");
            ((GShareWebMedia) shareMedia).setThumb(BitmapFactory.decodeResource(getResources(), R.drawable.ic_launcher));
        } else {
            return;
        }

        // 分享监听器
        MyShareListener shareListener = new MyShareListener();

        // 发起分享
        if (0 == nShareType) {// 通过第三方SDK分享
            GShareInterface.getInstance(this).doShareWithVendorSDK(this, GSharePlatformType.SDK_CHOOSE_PLATFORM, shareMedia, shareListener);
        } else {// 通过系统原生分享
            GShareInterface.getInstance(this).doShareWithSystemPrimal(this, GSharePlatformType.SDK_CHOOSE_PLATFORM, shareMedia, shareListener);
        }
    }

    // 录制屏幕按钮响应方法
    public void onBtnRecordSwitchClick(final View view) {
        // 初始化视频录制服务
        GShareInterface.initRecordService(this);

        MyShareListener shareListener = new MyShareListener();
        GShareRecordListener myListener = new GShareRecordListener() {
            @Override
            public void onStartRecordSuccess() {
                ((Button) view).setText("结束并分享");
            }

            @Override
            public void onStartRecordFailed(String message) {
                Toast.makeText(GShareEngineActivity.this, message, Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onEndRecordSuccess(final String videoPath) {
                Toast.makeText(GShareEngineActivity.this, "录屏成功" + videoPath, Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onEndRecordFailed(String message) {
                Toast.makeText(GShareEngineActivity.this, message, Toast.LENGTH_SHORT).show();
            }
        };

        if (((Button) view).getText().toString().equals("录屏开始")) {
            GShareInterface.startRecord(myListener);
        } else {
            ((Button) view).setText("录屏开始");
            GShareInterface.stopRecordAndShare(this, shareListener);
        }
    }

    // 分享监听
    public class MyShareListener implements GShareListener {
        @Override
        public void onComplete(GSharePlatformType platformType) {
            Toast.makeText(GShareEngineActivity.this, platformType + " " + " onComplete", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onError(GSharePlatformType platformType, String strErrMsg) {
            Toast.makeText(GShareEngineActivity.this, platformType + " share onError:" + strErrMsg, Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onCancel(GSharePlatformType platformType) {
            Toast.makeText(GShareEngineActivity.this, platformType + " share onCancel", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onOpen(GSharePlatformType platformType) {
            Toast.makeText(GShareEngineActivity.this, platformType + " app onOpen", Toast.LENGTH_SHORT).show();
//			GShareLogUtils.i("TAG", platformType + " app onOpen");
        }
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        if (Configuration.ORIENTATION_LANDSCAPE != newConfig.orientation) {
            this.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        GShareInterface.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        GShareInterface.onRequestPermissionsResult(requestCode, permissions, grantResults);
    }
}
