package com.ghome.sdk.demo.ui;

import android.annotation.SuppressLint;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Toast;

import com.ghome.gshare.GShareInterface;
import com.ghome.gshare.GSharePlatformType;
import com.ghome.gshare.listener.GShareListener;
import com.ghome.gshare.listener.GShareRecordListener;
import com.ghome.gshare.share_media.GShareBaseMedia;
import com.ghome.gshare.share_media.GShareSystemPrimalImageMedia;
import com.ghome.gshare.share_media.GShareSystemPrimalMusicMedia;
import com.ghome.gshare.share_media.GShareSystemPrimalVideoMedia;
import com.ghome.gshare.share_media.GShareTextMedia;
import com.ghome.gshare.share_media.GShareVendorSDKImageMedia;
import com.ghome.gshare.util.GShareBaseUtility;
import com.ghome.sdk.demo.R;
import com.ghome.sdk.demo.activity.BaseActivity;
import com.ghomesdk.gameplus.utils.log.Log;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * 作者: xiaoting.dani
 * 创建时间：2022/7/1
 * 说明：系统分享 测试功能页面
 **/
public class GShareFragment extends BaseFragment {
    private static final String TAG = GShareFragment.class.getSimpleName();

    private RadioGroup m_radioGShareMedia;
    private RadioGroup m_radioGSharePlatform;

    @SuppressLint("ValidFragment")
    public GShareFragment(BaseActivity act) {
        super(act);
    }

    public GShareFragment() {
    }

    private View view;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        Log.debug(TAG, "onCreate");
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        Log.debug(TAG, "onCreateView");
        checkContext();
        view = inflater.inflate(R.layout.gshare_primal_engine_fragment, container, false);
        m_radioGShareMedia = view.findViewById(R.id.radioGShareMedia);
        m_radioGSharePlatform = view.findViewById(R.id.radioGSharePlatform);

        initShareType();

        View radioShareText = view.findViewById(R.id.radioShareText);
        radioShareText.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBtnShareMediaTypeClick(v);
            }
        });

        View radioShareImage = view.findViewById(R.id.radioShareImage);
        radioShareImage.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBtnShareMediaTypeClick(v);
            }
        });

        View radioShareMusic = view.findViewById(R.id.radioShareMusic);
        radioShareMusic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBtnShareMediaTypeClick(v);
            }
        });

        View radioShareVideo = view.findViewById(R.id.radioShareVideo);
        radioShareVideo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBtnShareMediaTypeClick(v);
            }
        });


        View btnStartRecord = view.findViewById(R.id.btnStartRecord);
        btnStartRecord.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBtnRecordSwitchClick(v);
            }
        });

        View btShare = view.findViewById(R.id.btnShare);
        btShare.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                onBtnShareClick(v);
            }
        });

        return view;
    }

    // 本例中, 主要用于系统分享. 三方SDK只视频分享用此路径
    private void copyAssetsFileToSDCard(String strAssetsFilePath, String strOutFilePath) throws IOException {
        InputStream input;
        OutputStream output = new FileOutputStream(strOutFilePath);
        input = mContext.getAssets().open(strAssetsFilePath);
        if (null == input) {
            return;
        }
        byte[] buffer = new byte[1024];
        int length = input.read(buffer);
        while (0 < length) {
            output.write(buffer, 0, length);
            length = input.read(buffer);
        }
        output.flush();
        input.close();
        output.close();
    }

    // 分享方式 radio group 视图响应方法
    public void initShareType() {
        if (R.id.radioShareText == m_radioGShareMedia.getCheckedRadioButtonId()) {
            if (R.id.radioShareWXCircle == m_radioGSharePlatform.getCheckedRadioButtonId()) {
                ((RadioButton) view.findViewById(R.id.radioShareWX)).setChecked(true);
            }
            view.findViewById(R.id.radioShareWXCircle).setEnabled(false);
        } else if (R.id.radioShareVideo == m_radioGShareMedia.getCheckedRadioButtonId()) {
            if (R.id.radioShareQQ != m_radioGSharePlatform.getCheckedRadioButtonId()
                    && R.id.radioShareWX != m_radioGSharePlatform.getCheckedRadioButtonId()
                    && R.id.radioShareSDKPlatform != m_radioGSharePlatform.getCheckedRadioButtonId()) {
                ((RadioButton) view.findViewById(R.id.radioShareWX)).setChecked(true);
            }
            view.findViewById(R.id.radioShareWX).setEnabled(true);
            view.findViewById(R.id.radioShareQQ).setEnabled(true);
            view.findViewById(R.id.radioShareWXCircle).setEnabled(false);
            view.findViewById(R.id.radioShareQZone).setEnabled(false);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(false);
        } else if (R.id.radioShareMusic == m_radioGShareMedia.getCheckedRadioButtonId()) {
            if (R.id.radioShareQQ != m_radioGSharePlatform.getCheckedRadioButtonId() && R.id.radioShareSDKPlatform != m_radioGSharePlatform.getCheckedRadioButtonId()) {
                ((RadioButton) view.findViewById(R.id.radioShareQQ)).setChecked(true);
            }
            view.findViewById(R.id.radioShareWX).setEnabled(false);
            view.findViewById(R.id.radioShareWXCircle).setEnabled(false);
            view.findViewById(R.id.radioShareQZone).setEnabled(false);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(false);
        } else {

        }
        view.findViewById(R.id.radioShareQQ).setEnabled(true);
    }

    // 分享文件类型 radio group 视图响应方法
    public void onBtnShareMediaTypeClick(View view1) {
        int checkedRadioButtonId = m_radioGShareMedia.getCheckedRadioButtonId();
        if (checkedRadioButtonId == R.id.radioShareText) {
            if (R.id.radioShareWXCircle == m_radioGSharePlatform.getCheckedRadioButtonId()) {
                ((RadioButton) view.findViewById(R.id.radioShareWX)).setChecked(true);
            }
            view.findViewById(R.id.radioShareWXCircle).setEnabled(false);
            view.findViewById(R.id.radioShareQQ).setEnabled(true);
            view.findViewById(R.id.radioShareQZone).setEnabled(true);

            view.findViewById(R.id.radioShareWX).setEnabled(true);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(true);
        } else if (checkedRadioButtonId == R.id.radioShareImage) {
            view.findViewById(R.id.radioShareWX).setEnabled(true);
            view.findViewById(R.id.radioShareWXCircle).setEnabled(true);
            view.findViewById(R.id.radioShareQZone).setEnabled(true);

            view.findViewById(R.id.radioShareQQ).setEnabled(true);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(true);
        } else if (checkedRadioButtonId == R.id.radioShareMusic) {
            if (R.id.radioShareQQ != m_radioGSharePlatform.getCheckedRadioButtonId()
                    && R.id.radioShareSDKPlatform != m_radioGSharePlatform.getCheckedRadioButtonId()) {
                ((RadioButton) view.findViewById(R.id.radioShareQQ)).setChecked(true);
            }
            view.findViewById(R.id.radioShareWX).setEnabled(false);
            view.findViewById(R.id.radioShareWXCircle).setEnabled(false);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(false);

            view.findViewById(R.id.radioShareQZone).setEnabled(false);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(false);
            view.findViewById(R.id.radioShareQQ).setEnabled(true);
        } else if (checkedRadioButtonId == R.id.radioShareVideo) {
            if (R.id.radioShareQQ != m_radioGSharePlatform.getCheckedRadioButtonId()
                    && R.id.radioShareWX != m_radioGSharePlatform.getCheckedRadioButtonId()
                    && R.id.radioShareSDKPlatform != m_radioGSharePlatform.getCheckedRadioButtonId()) {
                ((RadioButton) view.findViewById(R.id.radioShareWX)).setChecked(true);
            }
            view.findViewById(R.id.radioShareWX).setEnabled(true);
            view.findViewById(R.id.radioShareQQ).setEnabled(true);
            view.findViewById(R.id.radioShareWXCircle).setEnabled(false);
            view.findViewById(R.id.radioShareQZone).setEnabled(false);
            view.findViewById(R.id.radioShareSinaWB).setEnabled(false);

        } else {
            return;
        }
    }

    // 触发分享
    public void onBtnShareClick(View view1) {
        // 分享的文件的存储位置.
        String externalFilesDirPath = "";
        try {
            externalFilesDirPath = mContext.getExternalFilesDir(null).toString();
        } catch (Exception e) {
            GShareBaseUtility.doLogger("get external files dir failed. Exception message is : " + e.getMessage());
        }

        // 分享的文件类型
        GShareBaseMedia shareMedia;
        int radioButtonId = m_radioGShareMedia.getCheckedRadioButtonId();
        if (radioButtonId == R.id.radioShareText) { // 文件类型为文字
            shareMedia = new GShareTextMedia();
            ((GShareTextMedia) shareMedia).setText("分享文字测试");
        } else if (radioButtonId == R.id.radioShareImage) { // 文件类型为图片
            //TODO  三方SDK分享方式
//                shareMedia = new GShareVendorSDKImageMedia();
//                ((GShareVendorSDKImageMedia) shareMedia).setImage(BitmapFactory.decodeResource(getResources(), R.drawable.gshare));


            shareMedia = new GShareSystemPrimalImageMedia();
            ((GShareSystemPrimalImageMedia) shareMedia).setDescription("http://baidu.com");

            try {
                // 图片保存到SDCard， 后面根据文件路径拿到文件进行分享
                copyAssetsFileToSDCard("gshare1.jpg", externalFilesDirPath + "/" + "gshare1.jpg");
                if (R.id.radioShareWXCircle != m_radioGSharePlatform.getCheckedRadioButtonId()) { // 分享平台非朋友圈则多分享一张图片
//                    copyAssetsFileToSDCard("gshare2.jpg", externalFilesDirPath + "/" + "gshare2.jpg");
                }
            } catch (IOException e) {
                e.printStackTrace();
            }

            String shareFilePath1 = externalFilesDirPath + "/" + "gshare1.jpg";
//            String shareFilePath2 = externalFilesDirPath + "/" + "gshare2.jpg";
            ((GShareSystemPrimalImageMedia) shareMedia).addMediaPath(shareFilePath1);
            if (R.id.radioShareWXCircle != m_radioGSharePlatform.getCheckedRadioButtonId()) { // 分享平台非朋友圈则多分享一张图片
//                ((GShareSystemPrimalImageMedia) shareMedia).addMediaPath(shareFilePath2);
            }
        } else if (radioButtonId == R.id.radioShareMusic) { // 类型为音乐
            shareMedia = new GShareSystemPrimalMusicMedia();
            ((GShareSystemPrimalMusicMedia) shareMedia).setDescription("音乐分享.");
            try {
                copyAssetsFileToSDCard("gshare1.mp3", externalFilesDirPath + "/" + "gshare1.mp3");
//                copyAssetsFileToSDCard("gshare2.mp3", externalFilesDirPath + "/" + "gshare2.mp3");
            } catch (IOException e) {
                e.printStackTrace();
            }

            String shareFilePath1 = externalFilesDirPath + "/" + "gshare1.mp3";
//            String shareFilePath2 = externalFilesDirPath + "/" + "gshare2.mp3";
            ((GShareSystemPrimalMusicMedia) shareMedia).addMediaPath(shareFilePath1);
//            ((GShareSystemPrimalMusicMedia) shareMedia).addMediaPath(shareFilePath2);
        } else if (radioButtonId == R.id.radioShareVideo) { // 分享视频
            shareMedia = new GShareSystemPrimalVideoMedia();
            ((GShareSystemPrimalVideoMedia) shareMedia).setDescription("视频分享.");
            try {
                copyAssetsFileToSDCard("gshare1.mp4", externalFilesDirPath + "/" + "gshare1.mp4");
            } catch (IOException e) {
                e.printStackTrace();
            }

            String shareFilePath1 = externalFilesDirPath + "/" + "gshare1.mp4";
            ((GShareSystemPrimalVideoMedia) shareMedia).addMediaPath(shareFilePath1);
        } else {
            return;
        }

        // 分享监听器
        MyShareListener shareListener = new MyShareListener();

        // 发起分享
        GSharePlatformType sharePlatform = GSharePlatformType.WEIXIN_PLATFORM;
        int checkedRadioButtonId = m_radioGSharePlatform.getCheckedRadioButtonId();
        if (checkedRadioButtonId == R.id.radioShareWX) {
            sharePlatform = GSharePlatformType.WEIXIN_PLATFORM;
        } else if (checkedRadioButtonId == R.id.radioShareWXCircle) {
            sharePlatform = GSharePlatformType.WEIXIN_CIRCLE_PLATFORM;
        } else if (checkedRadioButtonId == R.id.radioShareQQ) {
            sharePlatform = GSharePlatformType.QQ_PLATFORM;
        } else if (checkedRadioButtonId == R.id.radioShareQZone) {
            sharePlatform = GSharePlatformType.QZONE_PLATFORM;
        } else if (checkedRadioButtonId == R.id.radioShareSinaWB) {
            sharePlatform = GSharePlatformType.SINA_WB_PLATFORM;
        } else if (checkedRadioButtonId == R.id.radioShareSDKPlatform) {
            sharePlatform = GSharePlatformType.SDK_CHOOSE_PLATFORM;
        }
        GShareInterface.getInstance(mContext).doShareWithSystemPrimal(mContext, sharePlatform, shareMedia, shareListener);
    }

    // 录制屏幕按钮响应方法
    public void onBtnRecordSwitchClick(final View view) {
        // 初始化视频录制服务
        GShareInterface.getInstance(mContext).initRecordService(mContext);

        MyShareListener shareListener = new MyShareListener();

        GShareRecordListener myListener = new GShareRecordListener() {
            @Override
            public void onStartRecordSuccess() {
                ((Button) view).setText("结束并分享");
            }

            @Override
            public void onStartRecordFailed(String message) {
                Toast.makeText(mContext, message, Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onEndRecordSuccess(final String videoPath) {
                Toast.makeText(mContext, "录屏成功" + videoPath, Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onEndRecordFailed(String message) {
                Toast.makeText(mContext, message, Toast.LENGTH_SHORT).show();
            }
        };

        if (((Button) view).getText().toString().equals("录屏开始")) {
            GShareInterface.startRecord(myListener);
        } else {
            ((Button) view).setText("录屏开始");
            GShareInterface.stopRecordAndShare(mContext, shareListener);
        }

    }

    // 分享监听
    public class MyShareListener implements GShareListener {
        @Override
        public void onComplete(GSharePlatformType platformType) {
            Toast.makeText(mContext, platformType + "share onComplete", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onError(GSharePlatformType platformType, String strErrMsg) {
            Toast.makeText(mContext, platformType + " share onError:" + strErrMsg, Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onCancel(GSharePlatformType platformType) {
            Toast.makeText(mContext, platformType + " share onCancel", Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onOpen(GSharePlatformType platformType) {
            Toast.makeText(mContext, platformType + " app onOpen", Toast.LENGTH_SHORT).show();
        }
    }
}
