package com.ghome.sdk.demo.ui;

import android.annotation.SuppressLint;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import com.ghome.sdk.demo.R;

public class GameAgreementDialog extends Dialog {
    private String contentUrl;

    public GameAgreementDialog(Context context, int themeResId) {
        super(context, themeResId);
    }

    public void setContentUrl(String url) {
        contentUrl = url;
    }

    @SuppressLint("SetJavaScriptEnabled")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setCanceledOnTouchOutside(false);
        setContentView(R.layout.game_dialog_agreement);

        WebView webView = (WebView) findViewById(R.id.webview_agreement);

        findViewById(R.id.iv_close).setOnClickListener(v -> GameAgreementDialog.this.cancel());

        WebSettings webSettings = webView.getSettings();
        webSettings.setJavaScriptEnabled(true);

        webView.loadUrl(contentUrl);

        webView.setWebViewClient(new WebViewClient() {
            @Override
            public void onPageStarted(WebView view, String url, Bitmap favicon) {
                super.onPageStarted(view, url, favicon);
                android.util.Log.e("AgreementDialog", "onPageStarted： " + System.currentTimeMillis());
            }

            @Override
            public void onPageFinished(WebView view, String url) {
                super.onPageFinished(view, url);
                android.util.Log.e("AgreementDialog", "onPageFinished： " + System.currentTimeMillis() + "url: " + url);

            }
        });

        android.util.Log.e("AgreementDialog", System.currentTimeMillis() + "contentUrl: " + contentUrl);
    }


    @Override
    public void show() {
        super.show();
    }

}
