package com.ghome.sdk.demo.ui;

import android.annotation.SuppressLint;
import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.TextView;

import com.ghome.sdk.demo.R;
import com.ghome.sdk.demo.util.SharedPreferencesUtil;


/**
 * Created by xiaoting on 2021/12/01.
 * demo协议弹框
 */

public class GameAgreementOperationDialog extends Dialog {
    private String TAG = "AgreementOperationDialog";
    private String contentData;
    private GameAgreementOperationListener listener;

    public interface GameAgreementOperationListener {
        void onOperateCallback(boolean isAgree);
    }


    public GameAgreementOperationDialog(Context context, int themeResId) {
        super(context, themeResId);
    }

    public void setContentUrl(String conData) {
        contentData = conData;
    }

    public void setOperationListener(GameAgreementOperationListener listener) {
        this.listener = listener;
    }

    @SuppressLint("SetJavaScriptEnabled")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setCanceledOnTouchOutside(false);
        setContentView(R.layout.game_dialog_agreement_action);
        WebView webView = (WebView) findViewById(R.id.webview_agreement);

        TextView btAgree = (TextView) findViewById(R.id.bt_agree);
        TextView btDisagree = (TextView) findViewById(R.id.bt_disagree);

        btAgree.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                listener.onOperateCallback(true);
                GameAgreementOperationDialog.this.cancel();
            }
        });

        btDisagree.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                listener.onOperateCallback(false);
                GameAgreementOperationDialog.this.cancel();
            }
        });

        WebSettings webSettings = webView.getSettings();
        webSettings.setJavaScriptEnabled(true);
        webSettings.setTextZoom(100);

        webView.loadDataWithBaseURL(null, contentData, "text/html", "UTF-8", null);
        webView.setWebViewClient(new WebViewClient() {
            @Override
            public boolean shouldOverrideUrlLoading(WebView view, String url) {
                if (url.startsWith("http:") || url.startsWith("https:")) {
                    GameAgreementDialog agreementDialog = new GameAgreementDialog(getContext(), 0);
                    agreementDialog.setContentUrl(url);
                    agreementDialog.show();
                    return true;
                }

                return super.shouldOverrideUrlLoading(view, url);
            }
        });

        android.util.Log.e("GameAgreementDialog", System.currentTimeMillis() + "contentUrl: " + contentData);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void show() {
        super.show();
    }
}
