package com.ghome.sdk.demo.ui;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.ghome.sdk.GHome;
import com.ghome.sdk.common.IGHomeApi;
import com.ghome.sdk.common.IGHomeApi.Callback;
import com.ghome.sdk.demo.DemoConfig;
import com.ghome.sdk.demo.R;
import com.ghome.sdk.demo.activity.BaseActivity;
import com.ghome.sdk.demo.model.AreaInfoModel;
import com.ghome.sdk.demo.util.ConstantsUtil;
import com.ghome.sdk.demo.util.DemoToastUtil;
import com.ghome.sdk.demo.util.SharedPreferencesUtil;
import com.ghome.sdk.demo.util.gson.GsonUtil;
import com.google.gson.JsonSyntaxException;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class LoginAreaFragment extends BaseFragment {
    private static final String TAG = "LoginAreaFragment";

    @SuppressLint("ValidFragment")
    public LoginAreaFragment(BaseActivity act) {
        super(act);
    }

    public LoginAreaFragment() {
    }

    private ArrayList<AreaInfoModel> areasName;

    private View view;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        Log.d(TAG, "onCreate");
        super.onCreate(savedInstanceState);
    }

    @Override
    public void onDestroy() {
        view = null;
        areasName = null;
        super.onDestroy();
    }


    @Override
    public void onDestroyView() {
        view = null;
        areasName = null;
        super.onDestroyView();
    }

    protected void showAreas() {
        BaseAdapter adpater = new BaseAdapter() {
            @Override
            public View getView(int position, View convertView, ViewGroup parent) {
                if (convertView == null) {
                    convertView = LayoutInflater.from(mContext).inflate(R.layout.ghome_demo_arealistitem, null);
                }
                String areaInfo = areasName.get(position).getName() + "(" + areasName.get(position).getGroup_name() + ")";
                ((TextView) convertView.findViewById(R.id.area_name)).setText(areaInfo);
                return convertView;

            }

            @Override
            public long getItemId(int position) {
                return position;
            }

            @Override
            public Object getItem(int position) {
                return areasName.get(position);
            }

            @Override
            public int getCount() {
                return areasName.size();
            }
        };

        ListView areaList = (ListView) view.findViewById(R.id.arealistView);
        areaList.setAdapter(adpater);
        areaList.setOnItemClickListener(new OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
            	if (areasName.get(position) == null){return;}
                DemoToastUtil.showToast(mContext, areasName.get(position).getName());
                GHome.getInstance().loginArea(mContext, areasName.get(position).getArea_code(), areasName.get(position).getGroup_id());
                SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.AREA_CODE, areasName.get(position).getArea_code());
                SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.AREA_GROUP, areasName.get(position).getGroup_id());

                DemoConfig.areaID = areasName.get(position).getArea_code();
                DemoConfig.groupId = areasName.get(position).getGroup_id();
                DemoConfig.areaName = areasName.get(position).getName();

                JSONObject jsonExData = new JSONObject();
                try {
                    jsonExData.put("groupId", areasName.get(position).getGroup_id());            // 当前登录的游戏组ID
                    jsonExData.put("roleId", "R0010");            // 当前登录的玩家角色ID
                    jsonExData.put("roleName", "令狐一冲");        // 当前登录的玩家角色名
                    jsonExData.put("roleLevel", "99");            // 当前登录的玩家角色等级
                    jsonExData.put("zoneId", areasName.get(position).getArea_code());            // 当前登录的游戏区ID
                    jsonExData.put("zoneName", areasName.get(position).getName()); // 当前登录的游戏区服名称
                    jsonExData.put("roleCreateTime", System.currentTimeMillis() / 1000 + ""); // 角色创建时间戳
                    jsonExData.put("roleLevelUpdateTime", System.currentTimeMillis() / 1000 + ""); // 角色等级变化时间戳
                    jsonExData.put("submitType", "selectServer");

					jsonExData.put("roleBalance", "100");// 务必传一个数字，若无，传"0"
					jsonExData.put("vipLevel", "350");// 务必传一个数字，若无，传入"0"
					jsonExData.put("partyName", "无");//若没有就传"无"
					jsonExData.put("professionid", "0");//没有就传"0"
					jsonExData.put("Private", "无");//没有就传"无"
					jsonExData.put("gender", "女");//不能为空，不能为null，可传参数"男"、"女"、"无"
					jsonExData.put("payTotal", "0");//累计充值金额 元为单位，文不能为空，必须为数字，若没有就传"0"
					jsonExData.put("remainCoinNum", "0");//1级货币余额,例如此玩家钱袋里还有5000个元宝，不能为空，必须为数字，若无，传入"0"
					jsonExData.put("professionroleid", "12");//不能为空，不能为null，没有就传 "0"
					jsonExData.put("professionrolename", "无");//不能为空，不能为null，没有就传"无"
					jsonExData.put("power", "10000000");//不能为空，必须为数字,不能为null，没有就传“0”
					jsonExData.put("experience", "100909090");//不能为空，用户当前经验值，必须为数字,不能为null，若没有就传"0"
					jsonExData.put("balance", "0");//若没有则传 "0"

					jsonExData.put("partyid", "0");//不能为空，必须为数字,不能为null，若无，传入 “0”
					jsonExData.put("partyroleid", "0");//帮派会长/帮主必传1，其他可自定义，不能为空，不能为null，若无，传入 “0”
					jsonExData.put("partyrolename", "无");//不能为空，不能为null，若无，传入“无”

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                Map<String, String> params = new HashMap<String, String>();

                params.put("data", jsonExData.toString());

                GHome.getInstance().doExtend(mContext, IGHomeApi.EXTEND_COMMAND_SUBMIT_EXTEND_DATA, params, new Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0) {
                            System.out.println("选择服务器成功");
                        }
                    }
                });

                try {
                    jsonExData.put("submitType", "enterServer");

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                Map<String, String> params1 = new HashMap<String, String>();

                params1.put("data", jsonExData.toString());

                GHome.getInstance().doExtend(mContext, IGHomeApi.EXTEND_COMMAND_SUBMIT_EXTEND_DATA, params1, new Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0) {
                            System.out.println("进入服务器成功");
                        }
                    }
                });

                mContext.replaceFragment(BaseActivity.SHOW_FRAGMENT_MAIN);
            }
        });
    }

    private static class ListArea {
        public ArrayList<AreaInfoModel> getMessage() {
            return message;
        }

        private ArrayList<AreaInfoModel> message;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        Log.d(TAG, "onCreateView");
        checkContext();
        view = inflater.inflate(R.layout.ghome_demo_activity_loginarea, container, false);

        areasName = new ArrayList<AreaInfoModel>();
        GHome.getInstance().getAreaConfig(mContext, new Callback() {
            @Override
            public void callback(int code, String msg, Map<String, String> data) {
                if (code == 0 && data != null) {
                    try {
                        ListArea areasName0 = GsonUtil.fromJson(data.get("data"), ListArea.class);
                        areasName = areasName0.getMessage();
                        showAreas();
                    } catch (JsonSyntaxException e1) {
                        e1.printStackTrace();
                        Log.e(TAG, "JSONException:" + e1.getMessage());
                    }
                } else {
                    DemoToastUtil.showToast(mContext, "获取区服信息失败，请稍后再试..");
                }
            }
        });

        return view;
    }


}
