package com.ghome.sdk.demo.ui;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.ghome.sdk.GHome;
import com.ghome.sdk.common.Constants;
import com.ghome.sdk.common.IGHomeApi;
import com.ghome.sdk.common.IGHomeApi.Callback;
import com.ghome.sdk.demo.DemoConfig;
import com.ghome.sdk.demo.R;
import com.ghome.sdk.demo.activity.BaseActivity;
import com.ghome.sdk.demo.model.AgreementDetail;
import com.ghome.sdk.demo.model.GetAgreementVersionAContent;
import com.ghome.sdk.demo.util.ConstantsUtil;
import com.ghome.sdk.demo.util.DemoToastUtil;
import com.ghome.sdk.demo.util.SharedPreferencesUtil;
import com.ghome.sdk.demo.util.gson.GsonUtil;
import com.ghomesdk.gameplus.GamePlus;
import com.ghomesdk.gameplus.callback.PayCallback;
import com.ghomesdk.gameplus.config.Config;
import com.greport.ghomelog.model.IMEIUtil;

import org.json.JSONException;
import org.json.JSONObject;

import java.lang.ref.WeakReference;
import java.util.HashMap;
import java.util.Map;

public class MainFragment extends BaseFragment {

    private static final String TAG = "MainFragment";

    private String appid;
    private String areaid;
    private String groupId;


    WeakReference<BaseActivity> ctx;

    @SuppressLint("ValidFragment")
    public MainFragment(BaseActivity act) {
        super(act);
    }

    public MainFragment() {
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        System.out.println("------BaseActivity:onCreate");
        ctx = new WeakReference<>(mContext);
    }


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        checkContext();
        View view = inflater.inflate(R.layout.ghome_demo_fragment_main, container, false);

        TextView userid = view.findViewById(R.id.tv_userid);
        userid.setText("userId: " + SharedPreferencesUtil.getSharedPreferencesValue(ctx.get(), ConstantsUtil.USERID, ""));

        TextView tvAppId = view.findViewById(R.id.tv_appid);
        tvAppId.setText("appId: " + DemoConfig.GAME_ID);
        TextView tvAreaId = view.findViewById(R.id.areaId);
        tvAreaId.setText("areaId: " + DemoConfig.areaID);

        Button getTicketBut = (Button) view.findViewById(R.id.getTicketbut);
        getTicketBut.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                getTicket();
            }
        });

        getTicketBut.setFocusable(true);
        getTicketBut.setFocusableInTouchMode(true);
        getTicketBut.requestFocus();



        Button payButton = (Button) view.findViewById(R.id.paybut);
        EditText etPc = (EditText) view.findViewById(R.id.et_pc);
        EditText etOa = (EditText) view.findViewById(R.id.et_oa);
        final ToggleButton paystyle = view.findViewById(R.id.tb_pay_type);
        payButton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!paystyle.isChecked()){
                    try{
                        JSONObject dianquanPayParams = new JSONObject();
                        dianquanPayParams.put("appid", DemoConfig.GAME_ID);
                        dianquanPayParams.put("pc", etPc.getText().toString().trim().isEmpty() ? "3" : etPc.getText().toString().trim());
                        dianquanPayParams.put("oa", etOa.getText().toString().trim().isEmpty() ? "10" : etOa.getText().toString().trim());
                        dianquanPayParams.put("area", DemoConfig.areaID);
                        dianquanPayParams.put("group", DemoConfig.groupId);

                        GHome.getInstance().pay(mContext, "", "", "", "", dianquanPayParams.toString(), new Callback() {
                            @Override
                            public void callback(int code, String s, Map<String, String> map) {
                                if (code == 0) {
                                    // 支付成功
                                    DemoToastUtil.showToast(mContext, "支付成功");
                                } else {
                                    DemoToastUtil.showToast(mContext, "支付: " + s);
                                }
                            }
                        });
                    } catch (Exception e) {
                        Log.e(TAG, "json error: " + e.getMessage());
                    }
                } else {
                    ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_PAY);
                }
            }
        });

        final EditText etSensitiveW = view.findViewById(R.id.et_sensitive_word);
        Button btFilter = view.findViewById(R.id.bt_filterword);
        btFilter.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                GHome.getInstance().filterSensitiveWord(ctx.get(), etSensitiveW.getText().toString(), new IGHomeApi.Callback() {
                    @Override
                    public void callback(int code, String msg, Map<String, String> data) {
                        Toast.makeText(ctx.get(), "敏感词接口已调用 " + (data != null ? data.get("resultWord") : ""), Toast.LENGTH_SHORT).show();
                    }
                });

            }
        });

        Button switchAccountBut = (Button) view.findViewById(R.id.switchAccountbut);
        switchAccountBut.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View arg0) {
                System.out.println("Switch account");
                Bundle bundle = new Bundle();
                bundle.putBoolean("isSwitchAccount", true);
                ctx.get().isLogin = false;
                ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_START, bundle);
            }
        });

        Button logoutBut = (Button) view.findViewById(R.id.logoutbut);
        logoutBut.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                GHome.getInstance().logout(ctx.get(), new Callback() {
                    @Override
                    public void callback(int code, String msg, Map<String, String> data) {
                        if (code == 0) {
                            SharedPreferencesUtil.setSharedPreferences(ctx.get(), "demoScene", "ghome_logout");
                            DemoToastUtil.showToast(ctx.get(), "登出成功");
                            ctx.get().isLogin = false;
                            GHome.getInstance().showFloatIcon(getActivity(), false, IGHomeApi.FloatIconPosition.LeftTop);
                            ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_START);
                        } else {
                            DemoToastUtil.showToast(ctx.get(), "登出失败");
                        }

                        GHome.getInstance().kickOff(ctx.get());


                        //TODO extend submit
                        JSONObject jsonExData = new JSONObject();
                        try {
                            jsonExData.put("groupId", "1");            // 当前登录的游戏区ID
                            jsonExData.put("roleId", "10010");            // 当前登录的玩家角色ID
                            jsonExData.put("roleName", "令狐一冲");        // 当前登录的玩家角色名
                            jsonExData.put("roleLevel", "99");            // 当前登录的玩家角色等级
                            jsonExData.put("zoneId", DemoConfig.areaID);            // 当前登录的游戏区服ID
                            jsonExData.put("zoneName", DemoConfig.areaName); // 当前登录的游戏区服名称
                            jsonExData.put("roleCreateTime", System.currentTimeMillis() / 1000 + ""); // 角色创建时间戳
                            jsonExData.put("roleLevelUpdateTime", System.currentTimeMillis()  / 1000 + ""); // 角色等级变化时间戳
                            jsonExData.put("submitType", "exitServer");

                            jsonExData.put("roleBalance", "100");// 务必传一个数字，若无，传"0"
                            jsonExData.put("vipLevel", "350");// 务必传一个数字，若无，传入"0"
                            jsonExData.put("partyName", "无");//若没有就传"无"
                            jsonExData.put("professionid", "0");//没有就传"0"
                            jsonExData.put("Private", "无");//没有就传"无"
                            jsonExData.put("gender", "女");//不能为空，不能为null，可传参数"男"、"女"、"无"
                            jsonExData.put("payTotal", "0");//累计充值金额 元为单位，文不能为空，必须为数字，若没有就传"0"
                            jsonExData.put("remainCoinNum", "0");//1级货币余额,例如此玩家钱袋里还有5000个元宝，不能为空，必须为数字，若无，传入"0"
                            jsonExData.put("professionroleid", "12");//不能为空，不能为null，没有就传 "0"
                            jsonExData.put("professionrolename", "无");//不能为空，不能为null，没有就传"无"
                            jsonExData.put("power", "10000000");//不能为空，必须为数字,不能为null，没有就传“0”
                            jsonExData.put("experience", "100909090");//不能为空，用户当前经验值，必须为数字,不能为null，若没有就传"0"
                            jsonExData.put("balance", "0");//若没有则传 "0"

                            jsonExData.put("partyid", "0");//不能为空，必须为数字,不能为null，若无，传入 “0”
                            jsonExData.put("partyroleid", "0");//帮派会长/帮主必传1，其他可自定义，不能为空，不能为null，若无，传入 “0”
                            jsonExData.put("partyrolename", "无");//不能为空，不能为null，若无，传入“无”

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                        Map<String, String> params = new HashMap<String, String>();

                        params.put("data", jsonExData.toString());

                        GHome.getInstance().doExtend(mContext, IGHomeApi.EXTEND_COMMAND_SUBMIT_EXTEND_DATA, params, new Callback() {
                            @Override
                            public void callback(int code, String message, Map<String, String> data) {
                                if (code == 0) {
                                    System.out.println("退出服务器成功");
                                }
                            }
                        });
                    }
                });
            }
        });


        Handler mHandler = new Handler(Looper.getMainLooper()) {
            @Override
            public void handleMessage(Message msg) {
                super.handleMessage(msg);
                switch (msg.what) {
//                    case 0:
//                        refreshView();
//                        break;
                    case 1:
                        GHome.getInstance().showFloatIcon((Activity) new WeakReference<Context>(ctx.get()).get(), true, IGHomeApi.FloatIconPosition.LeftTop);
                        break;
                    default:
                        break;
                }
            }
        };


        Message msg = new Message();
        msg.what = 1;
        mHandler.sendMessageDelayed(msg, 1000);


        Button exitBut = (Button) view.findViewById(R.id.exit);
        exitBut.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                GHome.getInstance().doExtend(ctx.get(), IGHomeApi.EXTEND_COMMAND_EXIT_PAGE, new HashMap<String, String>(), new Callback() {

                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == Constants.ERROR_CODE_SUCCESS) {
                            GHome.getInstance().doExtend(ctx.get(), IGHomeApi.EXTEND_COMMAND_CONFIRM_EXIT_APP, new HashMap<String, String>(), null);
                            getActivity().finish();
                            android.os.Process.killProcess(android.os.Process.myPid());//获取pid
                            System.exit(0);
                        } else {
                            DemoToastUtil.showToast(getActivity(), "(demo toast)SDK不支持退出页，请游戏(demo)自己弹退出框");
                            final AlertDialog.Builder builder = new AlertDialog.Builder(ctx.get());
                            builder.setTitle("请确认").setMessage("确定退出游戏吗").setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    GHome.getInstance().doExtend(ctx.get(), IGHomeApi.EXTEND_COMMAND_CONFIRM_EXIT_APP, new HashMap<String, String>(), null);
                                    ctx.get().finish();
                                    System.exit(0);
                                }
                            }).setNeutralButton("取消", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                }
                            });
                            builder.setCancelable(false);
                            builder.show();
                        }
                    }
                });

            }
        });


        JSONObject jsonExData = new JSONObject();
        try {
            jsonExData.put("groupId", DemoConfig.groupId);            // 当前登录的游戏区ID
            jsonExData.put("roleId", "10010");            // 当前登录的玩家角色ID
            jsonExData.put("roleName", "令狐一冲");        // 当前登录的玩家角色名
            jsonExData.put("roleLevel", "99");            // 当前登录的玩家角色等级
            jsonExData.put("zoneId", DemoConfig.areaID);            // 当前登录的游戏区服ID
            jsonExData.put("zoneName", DemoConfig.areaName); // 当前登录的游戏区服名称
            jsonExData.put("roleCreateTime", System.currentTimeMillis() / 1000 + ""); // 角色创建时间戳
            jsonExData.put("roleLevelUpdateTime", System.currentTimeMillis()  / 1000 + ""); // 角色等级变化时间戳
            jsonExData.put("submitType", "createRole");

            jsonExData.put("roleBalance", "100");// 务必传一个数字，若无，传"0"
            jsonExData.put("vipLevel", "350");// 务必传一个数字，若无，传入"0"
            jsonExData.put("partyName", "无");//若没有就传"无"
            jsonExData.put("professionid", "0");//没有就传"0"
            jsonExData.put("Private", "无");//没有就传"无"
            jsonExData.put("gender", "女");//不能为空，不能为null，可传参数"男"、"女"、"无"
            jsonExData.put("payTotal", "0");//累计充值金额 元为单位，文不能为空，必须为数字，若没有就传"0"
            jsonExData.put("remainCoinNum", "0");//1级货币余额,例如此玩家钱袋里还有5000个元宝，不能为空，必须为数字，若无，传入"0"
            jsonExData.put("professionroleid", "12");//不能为空，不能为null，没有就传 "0"
            jsonExData.put("professionrolename", "无");//不能为空，不能为null，没有就传"无"
            jsonExData.put("power", "10000000");//不能为空，必须为数字,不能为null，没有就传“0”
            jsonExData.put("experience", "100909090");//不能为空，用户当前经验值，必须为数字,不能为null，若没有就传"0"
            jsonExData.put("balance", "0");//若没有则传 "0"

            jsonExData.put("partyid", "0");//不能为空，必须为数字,不能为null，若无，传入 “0”
            jsonExData.put("partyroleid", "0");//帮派会长/帮主必传1，其他可自定义，不能为空，不能为null，若无，传入 “0”
            jsonExData.put("partyrolename", "无");//不能为空，不能为null，若无，传入“无”

        } catch (JSONException e) {
            e.printStackTrace();
        }

        Map<String, String> params = new HashMap<String, String>();

        params.put("data", jsonExData.toString());

        GHome.getInstance().doExtend(mContext, IGHomeApi.EXTEND_COMMAND_SUBMIT_EXTEND_DATA, params, new Callback() {
            @Override
            public void callback(int code, String message, Map<String, String> data) {
                if (code == 0) {
                    System.out.println("创建角色成功");
                }
            }
        });

/*		Button checkGuestOrderBut = (Button)view.findViewById(R.id.checkGuestOrder);
		checkGuestOrderBut.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				*//*GamePlus.my_payCheckOrderStatus(ctx.get(), new PayCallback() {

					@Override
					public void callback(int code, String message, Map<String, String> data) {
						Log.debug(TAG,"单机支付校验结果：code == " + code);
						switch(code){
							case Constants.ERROR_GUEST_ORDERID_NOT_EXIT:
								//没有未完成订单
								Log.debug(TAG,"没有未完成订单");
								DemoToastUtil.showToast(ctx.get(), "没有未完成订单");
								break;
							case Constants.ERROR_GUEST_ORDERID_NOT_PASS:
								//设备id不一致，校验不通过
								Log.debug(TAG,"设备id不一致，校验不通过");
								DemoToastUtil.showToast(ctx.get(), "设备id不一致");
								break;
							case Constants.ERROR_CODE_SUCCESS:
								//校验成功，可发放道具
								Log.debug(TAG,"校验成功，可发放道具");
								DemoToastUtil.showToast(ctx.get(), "校验成功");
								break;
							default:
								//校验暂未成功，游戏可不做处理：
								Log.debug(TAG,"校验暂未成功，游戏可不做处理：");
								break;
							}
					}
				});*//*
			}
		});*/
        Button scanQRCode = (Button) view.findViewById(R.id.ScanQRCode);
        scanQRCode.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                GHome.getInstance().scanQRCode(getActivity(), "", new Callback() {

                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == Constants.ERROR_CODE_QR_LOGIN_SUCCESS) {
                            Log.d(TAG, "QRCODE_DEBUG扫码登录成功！！！");
                            DemoToastUtil.showToast(getActivity(), message);
                        } else if (code == Constants.ERROR_CODE_QR_PAY_SUCCESS) { //
                            Log.d(TAG, "QRCODE_DEBUG扫码支付成功！！！");
                            DemoToastUtil.showToast(getActivity(), message);
                        } else if (code == Constants.ERROR_PAY_FAILED) {
                            Log.d(TAG, "QRCODE_DEBUG扫码支付失败！！！ ");
                            DemoToastUtil.showToast(getActivity(), message);
                        } else if (code == Constants.ERROR_CODE_QR_RESULT) {
                            Log.d(TAG, "QRCODE_DEBUG ERROR_CODE_QR_RESULT！！！ ");
                            System.out.println(TAG + " qrdata=" + (data != null ? data.get("qrdata") : message));
                            DemoToastUtil.showToast(getActivity(), data != null ? data.get("qrdata") : message);
                        } else if (code == Constants.ERROR_CODE_QR_CANCELED) {
                            Log.d(TAG, "QRCODE_DEBUG扫码取消！！！ ");
                            DemoToastUtil.showToast(getActivity(), message);
                        } else if (code == Constants.ERROR_USER_NOT_LOGIN) {
                            Log.d(TAG, "QRCODE_DEBUG未登录！！！ ");
                            DemoToastUtil.showToast(getActivity(), message);
                        } else{
                            Log.d(TAG, "QRCODE_DEBUG else error！！！ ");
                            DemoToastUtil.showToast(getActivity(), message);
                        }
                    }
                });
            }
        });

        Button bindPhoneButton = view.findViewById(R.id.binded_phone_change);
        bindPhoneButton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                //第三方账号换绑手机号 start
                GHome.getInstance().changeThirdBindPhone(ctx.get(), "791000008", new Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0) {
                            Toast.makeText(ctx.get(), "关联成功", Toast.LENGTH_SHORT).show();
                        } else {
                            Toast.makeText(ctx.get(), "关联失败", Toast.LENGTH_SHORT).show();
                        }
                    }
                });
                //第三方账号换绑手机号 end
            }
        });

        Button getDeviceIdButton = (Button) view.findViewById(R.id.getDeviceId);
        getDeviceIdButton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
//                DemoToastUtil.showToast(ctx.get(), "设备ID：" + GHome.getInstance().getGHomeDeviceId(ctx.get()));
//                DemoToastUtil.showToast(ctx.get(), "设备ID(+oaid：" + IMEIUtil.getDeviceIdAndroidId(ctx.get()));
                Toast.makeText(ctx.get(), "设备ID：" + IMEIUtil.getDeviceIdAndroidId(ctx.get()), Toast.LENGTH_SHORT).show();
            }
        });

        Button getDeviceIdServer = (Button) view.findViewById(R.id.getDeviceIdServer);
        getDeviceIdServer.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(ctx.get(), "设备标识符(服务端)：" + Config.MEM_DEVICE_ID_SERVER, Toast.LENGTH_SHORT).show();
            }
        });

//        Button getJrTtOaidButton = (Button) view.findViewById(R.id.getJrttOaid);
//        getJrTtOaidButton.setOnClickListener(new OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                Toast.makeText(ctx.get(), "今日头条OAID：" + HeadlineSdk.getJrttOaid(), Toast.LENGTH_SHORT).show();
//            }
//        });

        Button checkApiParamNull = (Button) view.findViewById(R.id.bt_check_null);
        checkApiParamNull.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_CHECK_NULL_PARAM, null);
            }
        });

        Button getPrivacy = (Button) view.findViewById(R.id.getPrivacyService);
        getPrivacy.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                GHome.getInstance().getAgreement(ctx.get(), "791000008", new Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0 && data != null) {
                            String dataJson = data.get("data");
                            //游戏自己解析该json. json内容字段说明请看文档
                            GetAgreementVersionAContent content = GsonUtil.fromJson(dataJson, GetAgreementVersionAContent.class);
                            if (content != null) {
                                String agreementServiceUrl = null;
                                String agreementPrivacyUrl = null;
                                for (AgreementDetail detail : content.agreements) {
                                    if (detail != null) {
                                        if (detail.type == 1) {//服务协议
                                            agreementServiceUrl = detail.url;
                                        } else if (detail.type == 2) {//隐私政策
                                            agreementPrivacyUrl = detail.url;
                                        } else if (detail.type == 0) {//聚合页
                                        }
                                    }
                                }
                                Toast.makeText(ctx.get(), "隐私政策Url：" + agreementPrivacyUrl + "\n服务协议Url： " + agreementServiceUrl, Toast.LENGTH_SHORT).show();
                            }
                        }
                    }
                });
            }
        });

        Button getAgreCon = (Button) view.findViewById(R.id.getagreementcontent);
        getAgreCon.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                GHome.getInstance().getAgreementContent(ctx.get(), "791000008", new Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0 && data != null) {
                            String dataJson = data.get("data");
                            //游戏自己解析该json. json内容字段说明请看文档
                            GetAgreementVersionAContent content = GsonUtil.fromJson(dataJson, GetAgreementVersionAContent.class);
                            if (content != null) {
                                String agreementServiceCon = null;
                                String agreementPrivacyCon = null;
                                for (AgreementDetail detail : content.agreements) {
                                    if (detail != null) {
                                        if (detail.type == 1) {//服务协议
                                            agreementServiceCon = detail.content;
                                        } else if (detail.type == 2) {//隐私政策
                                            agreementPrivacyCon = detail.content;
                                        } else if (detail.type == 0) {//聚合页
                                        }
                                    }
                                }
                                Toast.makeText(ctx.get(), "隐私政策Content：" + agreementPrivacyCon + "\n服务协议Content： " + agreementServiceCon, Toast.LENGTH_LONG).show();
                            }
                        }
                    }
                });
            }
        });

        Button wxshare = (Button) view.findViewById(R.id.bt_share);
        wxshare.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_SHARE, null);

//                WXEntryThirdHandler.getInstance().handle(ctx.get(), new WXEntryThirdHandler.WXEntryThirdHandlerListener() {
//                    @Override
//                    public void onReq(BaseReq baseReq) {
//                        Log.debug(TAG, "wxentryThirdHandler onReq");
//                        Toast.makeText(ctx.get(), "Demo: WXEntryThirdHandler onReq", Toast.LENGTH_SHORT).show();
//
//                    }
//
//                    @Override
//                    public void onResp(BaseResp baseResp) {
//                        Log.debug(TAG, "wxentryThirdHandler onResp");
//                        Toast.makeText(ctx.get(), "Demo: WXEntryThirdHandler onResp 转发", Toast.LENGTH_SHORT).show();
//                        GShareInterface.getInstance(ctx.get()).onShareCallback((SendMessageToWX.Resp) baseResp);
//                    }
//                });
//
//                try{
//                    GShareInterface.getInstance(ctx.get().getApplicationContext());
//                }catch (Exception e){
//
//                }
//                GShareInterface.setWXAppID(Config.WEIXIN_APPID);
//
//                GShareInterface.intentToShare( "消灭世界boss黑暗魔王" );
//                // 获取分享类型
//                GShareTextMedia shareMedia = new GShareTextMedia();
//                ((GShareTextMedia) shareMedia).setText("分享文字测试");
//                GShareInterface.doShareWithVendorSDK(ctx.get(), GSharePlatformType.WEIXIN_PLATFORM, shareMedia, new GShareListener() {
//                    @Override
//                    public void onComplete(GSharePlatformType gSharePlatformType) {
//                        Log.debug("GShareInterface", "wxentryThirdHandler onComplete");
//                    }
//
//                    @Override
//                    public void onError(GSharePlatformType gSharePlatformType, String s) {
//                        Log.debug("GShareInterface", "wxentryThirdHandler onError");
//                    }
//
//                    @Override
//                    public void onCancel(GSharePlatformType gSharePlatformType) {
//                        Log.debug("GShareInterface", "wxentryThirdHandler onCancel");
//                    }
//
//                    @Override
//                    public void onOpen(GSharePlatformType gSharePlatformType) {
//                        Log.debug("GShareInterface", "wxentryThirdHandler onOpen");
//                    }
//                });
            }
        });

        Button getChildChannelCode = (Button) view.findViewById(R.id.bt_getchildchannel);
        getChildChannelCode.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                Toast.makeText(ctx.get(), "getCPSChannelCode: " + GHome.getInstance().getCPSChannelCode(ctx.get()), Toast.LENGTH_SHORT).show();
            }
        });

        Button deleAcct = view.findViewById(R.id.bt_dele_acct);
        deleAcct.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                GHome.getInstance().writtenOff(ctx.get(), new IGHomeApi.Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0) {
                            SharedPreferencesUtil.setSharedPreferences(ctx.get(), "demoScene", "ghome_logout");
                            DemoToastUtil.showToast(ctx.get(), "注销账号成功");
                            ctx.get().isLogin = false;
                            GHome.getInstance().showFloatIcon(getActivity(), false, IGHomeApi.FloatIconPosition.LeftTop);
                            ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_START);
                        } else {
                            Toast.makeText(ctx.get(), "demo: error code: " + code + ", error message: " + message, Toast.LENGTH_SHORT).show();
                        }
                    }
                });
            }
        });

        Button btLevelUp = (Button) view.findViewById(R.id.bt_levelup);
        btLevelUp.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                JSONObject jsonExData = new JSONObject();
                try {
                    jsonExData.put("groupId", DemoConfig.groupId);            // 当前登录的玩家角色ID
                    jsonExData.put("roleId", "10010");            // 当前登录的玩家角色ID
                    jsonExData.put("roleName", "令狐一冲");        // 当前登录的玩家角色名
                    jsonExData.put("roleLevel", "110");            // 当前登录的玩家角色等级
                    jsonExData.put("zoneId", DemoConfig.areaID);            // 当前登录的游戏区服ID
                    jsonExData.put("zoneName", "测试角色升级服"); // 当前登录的游戏区服名称
                    jsonExData.put("roleCreateTime", System.currentTimeMillis() / 1000 + ""); // 角色创建时间戳
                    jsonExData.put("roleLevelUpdateTime", System.currentTimeMillis() / 1000 + ""); // 角色等级变化时间戳
                    jsonExData.put("submitType", "levelUp");

                    jsonExData.put("roleBalance", "100");// 务必传一个数字，若无，传"0"
                    jsonExData.put("vipLevel", "350");// 务必传一个数字，若无，传入"0"
                    jsonExData.put("partyName", "无");//若没有就传"无"
                    jsonExData.put("professionid", "0");//没有就传"0"
                    jsonExData.put("Private", "无");//没有就传"无"
                    jsonExData.put("gender", "女");//不能为空，不能为null，可传参数"男"、"女"、"无"
                    jsonExData.put("payTotal", "0");//累计充值金额 元为单位，文不能为空，必须为数字，若没有就传"0"
                    jsonExData.put("remainCoinNum", "0");//1级货币余额,例如此玩家钱袋里还有5000个元宝，不能为空，必须为数字，若无，传入"0"
                    jsonExData.put("professionroleid", "12");//不能为空，不能为null，没有就传 "0"
                    jsonExData.put("professionrolename", "无");//不能为空，不能为null，没有就传"无"
                    jsonExData.put("power", "10000000");//不能为空，必须为数字,不能为null，没有就传“0”
                    jsonExData.put("experience", "100909090");//不能为空，用户当前经验值，必须为数字,不能为null，若没有就传"0"
                    jsonExData.put("balance", "0");//若没有则传 "0"

                    jsonExData.put("partyid", "0");//不能为空，必须为数字,不能为null，若无，传入 “0”
                    jsonExData.put("partyroleid", "0");//帮派会长/帮主必传1，其他可自定义，不能为空，不能为null，若无，传入 “0”
                    jsonExData.put("partyrolename", "无");//不能为空，不能为null，若无，传入“无”

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                Map<String, String> params = new HashMap<String, String>();
                params.put("data", jsonExData.toString());

                GHome.getInstance().doExtend(ctx.get(), IGHomeApi.EXTEND_COMMAND_SUBMIT_EXTEND_DATA, params, new Callback() {
                    @Override
                    public void callback(int code, String message, Map<String, String> data) {
                        if (code == 0) {
                            Log.d(TAG, "角色等级升级成功");
                            DemoToastUtil.showToast(ctx.get(), "角色等级升级成功");
                        }
                    }
                });
            }
        });

        wxshare = view.findViewById(R.id.bt_share);
        wxshare.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
//                ((Activity)ctx.get()).startActivity(new Intent((Activity)ctx.get(), GShareEngineActivity.class));
                ctx.get().replaceFragment(BaseActivity.SHOW_FRAGMENT_SHARE, null);

//                WXEntryThirdHandler.getInstance().handle(ctx.get(), new WXEntryThirdHandler.WXEntryThirdHandlerListener() {
//                    @Override
//                    public void onReq(BaseReq baseReq) {
//                        Log.debug(TAG, "wxentryThirdHandler onReq");
//                        Toast.makeText(ctx.get(), "Demo: WXEntryThirdHandler onReq", Toast.LENGTH_SHORT).show();
//
//                    }
//
//                    @Override
//                    public void onResp(BaseResp baseResp) {
//                        Log.debug(TAG, "wxentryThirdHandler onResp");
//                        Toast.makeText(ctx.get(), "Demo: WXEntryThirdHandler onResp 转发 retCode: " + baseResp.errCode + ", message: " + baseResp.errStr, Toast.LENGTH_SHORT).show();
//                        GShareInterface.onShareCallback((SendMessageToWX.Resp) baseResp);
//                    }
//                });
//
//
//                try{
//                    GShareInterface.getInstance(ctx.get().getApplicationContext());
//                }catch (Exception e){
//
//                }
//                GShareInterface.setWXAppID(Config.WEIXIN_APPID);
//                GShareInterface.setQQAppID(Config.QQ_APPID);
//                GShareInterface.setSinaWBAppKey(Config.WEIBO_APPKEY);
//
//
//                GShareInterface.intentToShare( "消灭世界boss黑暗魔王" );
//                // 获取分享类型
//                GShareTextMedia shareMedia = new GShareTextMedia();
//                shareMedia.setText("分享文字测试");
//                GShareInterface.doShareWithVendorSDK(ctx.get(), GSharePlatformType.SDK_CHOOSE_PLATFORM, shareMedia, new GShareListener() {
//                    @Override
//                    public void onComplete(GSharePlatformType gSharePlatformType) {
//                        Log.debug("GShareInterface", "doShareWithVendorSDK onComplete: " + gSharePlatformType.name());
//                    }
//
//                    @Override
//                    public void onError(GSharePlatformType gSharePlatformType, String s) {
//                        Log.debug("GShareInterface", "doShareWithVendorSDK onError: " + gSharePlatformType.name());
//                    }
//
//                    @Override
//                    public void onCancel(GSharePlatformType gSharePlatformType) {
//                        Log.debug("GShareInterface", "doShareWithVendorSDK onCancel: " + gSharePlatformType.name());
//                    }
//
//
//                    @Override
//                    public void onOpen(GSharePlatformType gSharePlatformType){
//                        Log.debug("GShareInterface", "doShareWithVendorSDK onOpen: " + gSharePlatformType.name());
//                    }
//
//                });
            }
        });

//        Button wxsharegshare = view.findViewById(R.id.bt_share);
//        wxsharegshare.setOnClickListener(new OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                ((Activity)ctx.get()).startActivity(new Intent((Activity)ctx.get(), GShareEngineBackupActivity.class));
//            }
//        });


        return view;
    }

    // 起始时间戳
    protected long startTime = System.currentTimeMillis();
    // 运行log
    protected StringBuffer log = new StringBuffer("startTime:----------------" + startTime + "---------\n");

    protected Runnable mShowLog = new Runnable() {
        public void run() {
//            logTextView.setText(log.toString());
        }
    };

    private void getTicket() {
        appid = DemoConfig.GAME_ID;
        areaid = DemoConfig.areaID;
        groupId = DemoConfig.groupId;
        GHome.getInstance().getTicket(ctx.get(), appid, areaid, new Callback() {
            @Override
            public void callback(int code, String msg, Map<String, String> data) {
                if (code == 0) {
                    if (data != null) {
                        final String ticket = data.get("ticket");
                        TextView txtViewTicket = MainFragment.this.getActivity().findViewById(R.id.tv_ticket);
                        if (txtViewTicket != null) {
                            txtViewTicket.setText("ticket: " + ticket);
                        }
                    } else {
                        DemoToastUtil.showToast(ctx.get(), "网络出错，请稍后再试..");
                    }
                } else {
                    DemoToastUtil.showToast(ctx.get(), "code:" + code + " msg:" + msg);
                }
            }
        });
    }

    /**
     * 打印log到界面
     *
     * @param info
     */
//    protected void printLogOnScreen(String info) {
//        log.append(info + "\n");
////        ctx.get().getHandler().post(mShowLog);
//    }

//    private void refreshView() {
//        String moneyString = SharedPreferencesUtil.getSharedPreferencesValue(getActivity(), ConstantsUtil.MONEY, "-1");
//        String newestMoneyString = SharedPreferencesUtil.getSharedPreferencesValue(getActivity(), ConstantsUtil.NEWESTMONEY, "-1");
//        int money = Integer.parseInt(moneyString);
//        int newestMoney = Integer.parseInt(newestMoneyString);
//        int total = 0;
//        boolean paysuccess = SharedPreferencesUtil.getSharedPreferencesValue(ctx.get(), ConstantsUtil.PAYSUCCESS, false);
//        if (money > 0) {
//            if (newestMoney > 0) {
//                if (paysuccess) {
//                    total = money + newestMoney;
//                    SharedPreferencesUtil.setSharedPreferences(ctx.get(), ConstantsUtil.NEWESTMONEY, "0");
//                } else {
//                    total = money;
//                }
//            } else {
//                total = money;
//            }
//        } else {
//            if (newestMoney > 0) {
//                if (paysuccess) {
//                    total = newestMoney;
//                    SharedPreferencesUtil.setSharedPreferences(ctx.get(), ConstantsUtil.NEWESTMONEY, "0");
//                } else {
//                    total = 0;
//                }
//            } else {
//                total = 0;
//            }
//        }
//        SharedPreferencesUtil.setSharedPreferences(ctx.get(), ConstantsUtil.MONEY, total + "");
//        if (total == 0) {
//            moneyView.setText("0.00");
//        } else {
//            moneyView.setText(((double) total / 100) + "");
//        }
//    }

}
