package com.ghome.sdk.demo.ui;

import java.util.ArrayList;
import java.util.Map;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.BaseAdapter;
import android.widget.ListView;
import android.widget.TextView;

import com.ghome.sdk.demo.util.DemoToastUtil;
import com.ghome.sdk.demo.util.ItemNoFastClickListener;
import com.ghome.sdk.demo.R;
import com.ghome.sdk.GHome;
import com.ghome.sdk.common.IGHomeApi.Callback;
import com.ghome.sdk.demo.activity.BaseActivity;
import com.ghome.sdk.demo.model.ProductInfoModel;
import com.ghome.sdk.demo.util.ConstantsUtil;
import com.ghome.sdk.demo.util.SharedPreferencesUtil;

public class PayFragment extends BaseFragment {
	@SuppressLint("ValidFragment")
	public PayFragment(BaseActivity act) {
		super(act);
	}

	public PayFragment() {
	}

	private BaseAdapter adapter;
	private ListView productListView;
	private ArrayList<ProductInfoModel> productsList;
	
	View view;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		
		
	}

	protected void showProducts() {
		adapter = new BaseAdapter() {
			@Override
			public View getView(int position, View convertView, ViewGroup parent) {
				if (convertView == null) {
					convertView = LayoutInflater.from(mContext).inflate(R.layout.ghome_demo_product_item, null);
				}
				((TextView) convertView.findViewById(R.id.proName)).setText(productsList.get(position).getItemName());
				((TextView) convertView.findViewById(R.id.proMoney)).setText(productsList.get(position).getMoney() + "");

				return convertView;
			}

			@Override
			public long getItemId(int position) {
				return position;
			}

			@Override
			public Object getItem(int position) {
				return productsList.get(position);
			}

			@Override
			public int getCount() {
				return productsList.size();
			}
		};
		
		productListView = (ListView) view.findViewById(R.id.productlistView);
		productListView.setAdapter(adapter);

		productListView.setOnItemClickListener(new ItemNoFastClickListener() {
			@Override
			public void onNoFastClick(AdapterView<?> parent, View view, final int position, long id) {

				String orderId = "order123456123456";
				String areaId = SharedPreferencesUtil.getSharedPreferencesValue(mContext, ConstantsUtil.AREA_CODE, "");
				String groupId = SharedPreferencesUtil.getSharedPreferencesValue(mContext, ConstantsUtil.AREA_GROUP, "");
				String productId = productsList.get(position).getProductCode();
				String extend = "suibian";
				SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.PAYSUCCESS, false);
				GHome.getInstance().pay(mContext, groupId, orderId, areaId, productId, extend, new Callback() {
					@Override
					public void callback(int code, String msg, Map<String, String> data) {
						if (data != null) {
							SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.ORDERID, (String) data.get("orderid"));
						} else {
							SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.ORDERID, "orderid");
						}
						int money = (int)(productsList.get(position).getMoney() * 100);
						SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.NEWESTMONEY, money + "");
						if (code == 0) {
							// 支付成功
							SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.PAYSUCCESS, true);
							DemoToastUtil.showToast(mContext, "支付成功");
						} else {
							DemoToastUtil.showToast(mContext, msg);
						}
					}
				});
			}
		});
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {

		checkContext();
		view = inflater.inflate(R.layout.ghome_demo_activity_apy, container, false);
		
		productsList = new ArrayList<ProductInfoModel>();
		GHome.getInstance().getProductConfig(mContext, new Callback() {
			@Override
			public void callback(int code, String mag, Map<String, String> data) {
				if (code == 0) {
					System.out.println("------product:" + data.toString());
					try {
						JSONObject json = new JSONObject((String) data.get("data"));
						JSONArray jsonArray = json.getJSONArray("message");

						for (int i = 0; i < jsonArray.length(); i++) {
							System.out.println("jsonArray.get(i)" + jsonArray.get(i));
							ProductInfoModel model = new ProductInfoModel();
							model.setItemName(((JSONObject) jsonArray.get(i)).getString("item_name"));
							model.setProductCode(((JSONObject) jsonArray.get(i)).getString("product_code"));
							model.setType(((JSONObject) jsonArray.get(i)).getString("type"));
							double money = Double.parseDouble(((JSONObject) jsonArray.get(i)).getString("money"));
							model.setMoney(money);
							productsList.add(model);
						}
						showProducts();
					} catch (JSONException e) {
						e.printStackTrace();
					}
				} else {
					DemoToastUtil.showToast(mContext, "获取商品信息失败，请稍后再试..");
				}
			}
		});
		
		return view;
	}

	
	
}
