package com.ghome.sdk.demo.ui;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import android.widget.Toast;
import android.widget.ToggleButton;

import com.ghome.sdk.GHome;
import com.ghome.sdk.Version;
import com.ghome.sdk.common.Constants;
import com.ghome.sdk.common.IGHomeApi;
import com.ghome.sdk.demo.DemoConfig;
import com.ghome.sdk.demo.R;
import com.ghome.sdk.demo.activity.BaseActivity;
import com.ghome.sdk.demo.util.ConstantsUtil;
import com.ghome.sdk.demo.util.DemoToastUtil;
import com.ghome.sdk.demo.util.SharedPreferencesUtil;
import com.greport.ghomelog.model.IMEIUtil;
import com.greport.ghomelog.model.PhoneInfoUtil;

import java.util.Map;


public class StartFragment extends BaseFragment {

    String TAG = StartFragment.class.getSimpleName();

    @SuppressLint("ValidFragment")
    public StartFragment(BaseActivity act) {
        super(act);
    }

    public StartFragment() {
    }

    private GHome mGHome = null;
    private boolean isSwitchAccount = false;

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
    }

    @SuppressLint("HandlerLeak")
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mGHome = GHome.getInstance();

        mGHome.setGHomeSDKDebuggable(true);

//        String ad = SignatureUtil.getApkSignMd5(mContext);
//        Log.e("StartFragment", "获取签名: " + ad);

        //TODO test 自定义环境
//        GHome.setGHomeDomainNormal("https://mgame-gray.sdo.com");
//        GHome.setGHomeDomainPay("https://mgame.sdo.com");
//        GHome.setGHomeSdkHostApiAgreement("https://utility.sdoprofile.com");
//        GHome.setGHomeSdkHostApiAdv("https://adv.sdo.com");
//        GHome.setGHomeSdkHostApiRevokeUrl("https://sdkdl.sdoprofile.com/ghome/ghome_revoke.html");
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        checkContext();
        View view = inflater.inflate(R.layout.ghome_demo_activity_start, container, false);

        final EditText gameIdEditText = (EditText) view.findViewById(R.id.editText);
        TextView version = (TextView) view.findViewById(R.id.version);
        version.setText(Version.VERSION);
        gameIdEditText.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                gameIdEditText.setHint(null);
            }
        });

        gameIdEditText.setOnEditorActionListener(new OnEditorActionListener() {

            @Override
            public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
                return false;
            }
        });

//        final EditText etHumeCode = view.findViewById(R.id.et_hume_code);
//        Button btSetHumeCode = view.findViewById(R.id.bt_set);
//        etHumeCode.setOnClickListener(new OnClickListener() {
//            public void onClick(View v) {
//                etHumeCode.setHint(null);
//            }
//        });
//
//        btSetHumeCode.setOnClickListener(v -> {
//            Config.GHUME_CHANNEL_ID = etHumeCode.getText().toString();
//            Toast.makeText(mContext, "模拟设置分包渠道号成功", Toast.LENGTH_SHORT).show();
//        });

        final EditText etPaydomain = view.findViewById(R.id.et_pay_domain);
        Button btSetPay = view.findViewById(R.id.bt_set_pay);

        btSetPay.setOnClickListener(v -> {
            GHome.setGHomeDomainNormal(etPaydomain.getText().toString());
            GHome.setGHomeDomainPay(etPaydomain.getText().toString());
            Toast.makeText(mContext, "域名切换成功", Toast.LENGTH_SHORT).show();
        });


        final TextView tv_deviceinfo = view.findViewById(R.id.tv_deviceinfo);

        final Button initButton = (Button) view.findViewById(R.id.initButton);
        final Button agreeBt = view.findViewById(R.id.agreeButton);

        final ToggleButton tgPrivacy = view.findViewById(R.id.tb_privacy);

        if(DemoConfig.GAME_ID != null && !DemoConfig.GAME_ID.isEmpty()){
            gameIdEditText.setText(DemoConfig.GAME_ID);
        }
        mContext.gameId = gameIdEditText.getText().toString().trim();
        DemoConfig.GAME_ID = mContext.gameId;
        agreeBt.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
//                TODO test
//                if(true){
//                    mContext.startActivity(new Intent(mContext, QRCodeScanActivityNew.class));
//                    return;
//                }

                if (tgPrivacy.isChecked()) {
                    initButton.setEnabled(false);
                    mContext.isGamePrivacy = true;
                    //模拟游戏方自己处理隐私政策展示功能
                    //获取是否需要弹窗的status start
                    mContext.gameId = gameIdEditText.getText().toString().trim();
                    DemoConfig.GAME_ID = mContext.gameId;
                    GHome.getInstance().getAgreementStatus(mContext, mContext.gameId, false, new IGHomeApi.Callback() {
                        @Override
                        public void callback(int code, String message, final Map<String, String> data) {
                            if (code == 0 && data != null && data.get("status") != null && data.get("status").equals("1")) {
                                //模拟游戏方自己处理隐私政策展示功能
                                //弹协议框start
                                GameAgreementOperationDialog agreementDialog1 = new GameAgreementOperationDialog(getActivity(), 0);
                                agreementDialog1.setContentUrl(data.get("privacyContent"));//聚合页
                                agreementDialog1.setOperationListener(new GameAgreementOperationDialog.GameAgreementOperationListener() {
                                    @Override
                                    public void onOperateCallback(boolean isAgree) {
                                        if (isAgree) {
                                            initButton.setEnabled(true);
                                            GHome.getInstance().onUserAgreement(mContext, true, true);
                                        } else {
                                            GHome.getInstance().onUserAgreement(mContext, true, false);
                                            mContext.finish();
                                            System.exit(0);
                                        }
                                    }
                                });
                                agreementDialog1.show();
                                //弹协议框end
                            } else {
                                initButton.setEnabled(true);
                                Toast.makeText(getActivity(), "无需弹框,走已同意处理", Toast.LENGTH_SHORT).show();

                                GHome.getInstance().onUserAgreement(mContext, false, true);
                            }
                        }
                    });
                    //获取是否需要弹窗的status end
                } else {
                    mContext.isGamePrivacy = false;
                    mContext.gameId = gameIdEditText.getText().toString().trim();
                    DemoConfig.GAME_ID = mContext.gameId;
                    GHome.getInstance().doPrivacyAgreement(mContext, mContext.gameId, new IGHomeApi.Callback() {
                        @Override
                        public void callback(int code, String message, Map<String, String> data) {
                            if (code == Constants.ERROR_CODE_SUCCESS) {
                                String sb = "PhoneInfo: " + PhoneInfoUtil.getInfoJson(mContext) + ", ServerParamsDeviceId(imei-androidId): " + "\"" + IMEIUtil.getDeviceIdAndroidId(mContext) + "\""
                                        + ", packageName: " + "\"" + mContext.getPackageName() + "\"";
                                tv_deviceinfo.setText(sb);
                                //调用了sdk的隐私政策功能并得到同意，随后可进行初始化

                            } else {//玩家不同意隐私政策，直接退出
                                DemoToastUtil.showToast(mContext, "玩家不同意隐私政策");
//                                mContext.finish();
                            }
                        }
                    });
                }
            }
        });

        initButton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                mContext.gameId = gameIdEditText.getText().toString().trim();
                DemoConfig.GAME_ID = mContext.gameId;
                mGHome.initialize(mContext, mContext.gameId, mContext.initCallback);

                String sb = "PhoneInfo: " + PhoneInfoUtil.getInfoJson(mContext) + ", ServerParamsDeviceId(imei-androidId): " + "\"" + IMEIUtil.getDeviceIdAndroidId(mContext) + "\"" + ", packageName: " + "\"" + mContext.getPackageName() + "\"";
                tv_deviceinfo.setText(sb);
            }
        });

        Button loginButton = (Button) view.findViewById(R.id.loginButton);
        loginButton.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mContext.isGamePrivacy) {
                    GHome.getInstance().getAgreementStatus(mContext, mContext.gameId, true, new IGHomeApi.Callback() {
                        @Override
                        public void callback(int code, String message, Map<String, String> data) {
                            if (code == 0 && data != null && data.get("status") != null && data.get("status").equals("1")) {
                                //模拟游戏方自己处理隐私政策展示功能
                                //弹协议框start
                                GameAgreementOperationDialog agreementDialog1 = new GameAgreementOperationDialog(getContext(), 0);
                                agreementDialog1.setContentUrl(data.get("privacyContent"));//聚合页
                                agreementDialog1.setOperationListener(new GameAgreementOperationDialog.GameAgreementOperationListener() {
                                    @Override
                                    public void onOperateCallback(boolean isAgree) {
                                        if (isAgree) {
                                            String sb = "PhoneInfo: " + PhoneInfoUtil.getInfoJson(mContext) + ", ServerParamsDeviceId(imei-androidId): " + "\"" + IMEIUtil.getDeviceIdAndroidId(mContext) + "\"" + ", packageName: " + "\"" + mContext.getPackageName() + "\"";
                                            tv_deviceinfo.setText(sb);
                                            GHome.getInstance().onUserAgreement(mContext, true, true);
                                            mGHome.login(mContext, mContext.loginCallback);
                                        } else {
                                            GHome.getInstance().onUserAgreement(mContext, true, false);
                                            getActivity().finish();
                                            System.exit(0);
                                        }
                                    }
                                });
                                agreementDialog1.show();
                                //弹协议框end
                            } else {
                                mGHome.login(mContext, mContext.loginCallback);
                            }
                        }
                    });
                } else {
                    mGHome.login(mContext, mContext.loginCallback);
                }

            }
        });

        checkIsSwitchAccount();
        return view;
    }

    private void checkIsSwitchAccount() {
        isSwitchAccount = getArguments() != null && getArguments().getBoolean("isSwitchAccount");
        if (isSwitchAccount && !mContext.isLogin) {
            IGHomeApi.Callback agreementCallback = new IGHomeApi.Callback() {
                @Override
                public void callback(int code, String message, Map<String, String> data) {
                    if (code == 0) {
                        //弹游戏自己的隐私政策弹框
                        if (mContext.isGamePrivacy) {
                            if (data != null && data.get("status") != null && data.get("status").equals("1")) {
                                //模拟游戏方自己处理隐私政策展示功能 start
                                GameAgreementOperationDialog agreementDialog1 = new GameAgreementOperationDialog(getContext(), 0);
                                agreementDialog1.setContentUrl(data.get("privacyContent"));//聚合页
                                agreementDialog1.setOperationListener(new GameAgreementOperationDialog.GameAgreementOperationListener() {
                                    @Override
                                    public void onOperateCallback(boolean isAgree) {
                                        GHome.getInstance().onUserAgreement(mContext, true, isAgree);
                                    }
                                });
                                agreementDialog1.show();
                                //模拟游戏方自己处理隐私政策展示功能 end
                            } else {
                                GHome.getInstance().onUserAgreement(mContext, false, true);
                            }
                        }
                    } else {
                    }
                }
            };

            GHome.getInstance().switchAccount(mContext, mContext.isGamePrivacy ? agreementCallback : null, (code, msg, data) -> {
                if (code == 0) {
                    DemoToastUtil.showToast(mContext, "切换账户成功");

                    SharedPreferencesUtil.setSharedPreferences(mContext, ConstantsUtil.USERID, (String) data.get("userid"));
                    final String ticket = (String) data.get("ticket");
                    System.out.println("userid=" + data.get("userid"));
                    System.out.println("ticket=" + ticket);

                    mContext.isLogin = true;
                    mContext.getHandler().sendEmptyMessage(0);
                } else {
                    DemoToastUtil.showToast(mContext, "切换账户失败");
                    GHome.getInstance().kickOff(mContext);
                }
            });
        }
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    public void onDetach() {
        super.onDetach();
    }

    @Override
    public void onPause() {
        super.onPause();
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onStop() {
        super.onStop();
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
    }

    @Override
    public void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
    }

//    public static String getTicketStatusUrl(String ticket) {
//        return Config.DOMAIN + "/v1/account/demoLogin?ticket=" + ticket;
//    }

}
