package com.ghome.sdk.demo.util;

import android.view.View;
import android.widget.AdapterView;

import com.ghomesdk.gameplus.utils.FastClickChecker;

/**
 * Created by xiaoting.dani on 2021/11/24.
 * Describe:
 */
public abstract class ItemNoFastClickListener implements AdapterView.OnItemClickListener {
    private final FastClickChecker checker = new FastClickChecker();

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        if(!checker.isFastClick()){
            onNoFastClick(parent, view, position, id);
        }
    }

    public abstract void onNoFastClick(AdapterView<?> parent, View view, int position, long id);
}
